#!/usr/bin/env python2

import sys, os, os.path

new_names = str.split(
'''furnace_source furnace_result player_quickbar player_main player_guns
player_tools player_ammo player_armor assembling_machine_input
assembling_machine_output assembling_machine_modules lab_input lab_modules
mining_drill_modules go_to_location attack_area build_base by_enemy by_anything
by_damage on_tick on_gui_click on_entity_died on_picked_up_item on_built_entity
on_sector_scanned on_player_mined_item on_put_item on_rocket_launched
on_preplayer_mined_item on_chunk_generated on_player_crafted_item
on_robot_built_entity on_robot_pre_mined on_robot_mined on_research_started
on_research_finished on_player_rotated_entity on_marked_for_deconstruction
on_canceled_deconstruction on_trigger_created_entity on_train_changed_state
on_player_created on_resource_depleted on_player_driving_changed_state
material_type on_the_path path_lost no_schedule no_path arrive_signal
wait_signal arrive_station wait_station manual_control_stop manual_control
stop_for_auto_control signal_state is_demo collides_with trigger_created_entity
show_entity_info item_stack inventory_index left_top right_bottom structure_type
_current_package _current_path_in_package entity_info active_window
crafting_queue crafting_queueindex item_stack inventory_index item_stack_index
inner_name max_distance manual_mode manual_mode add_member set_command
set_autonomous start_moving research_unit_ingredients research_unit_count
research_unit_energy get_pollution can_place_entity find_entity find_entities
find_entities_filtered find_non_colliding_position find_enemy_units
find_nearest_enemy set_multi_command create_entity create_unit_group
build_enemy_base get_tile get_tileproperties set_tiles get_chunks
is_chunk_generated minimal_width maximal_width minimal_height maximal_height
top_padding right_padding bottom_padding left_padding font_color
resize_row_to_width minimal_width minimal_height maximal_width maximal_height
top_padding right_padding bottom_padding left_padding font_color
resize_row_to_width has_flag max_health infinite_resource
minimum_resource_amount resource_category mineable_properties
items_to_place_this collision_box selection_box healing_per_tick
emissions_per_tick selectable_in_game fast_replaceable_group
repair_speed_modifier get_inventory can_insert set_gui_arrow clear_gui_arrow
get_item_count has_items_inside can_reach_entity clear_items_inside remove_item
update_selected_entity clear_selected_entity disable_flashlight
crafting_queue_size walking_state riding_state mining_state cursor_stack
walking_state riding_state mining_state cursor_stack get_output_inventory
set_command has_command has_flag add_market_item connect_neighbour
disconnect_neighbour order_deconstruction cancel_deconstruction
to_be_deconstructed get_filter set_filter clear_filter get_request_slot
set_request_slot clear_request_slot get_circuit_condition set_circuit_condition
clear_circuit_condition is_crafting is_opened is_opening is_closed is_closing
request_to_open request_to_close ghost_name localised_name ghost_localised_name
ghost_type effectivity_modifier consumption_modifier friction_modifier
ghost_prototype drop_position drop_target selected_gun_index held_stack
backer_name time_to_live signal_state to_be_looted crafting_progress
bonus_progress belt_to_ground_type effectivity_modifier consumption_modifier
friction_modifier held_stack selected_gun_index backer_name time_to_live
to_be_looted max_shield max_solar_power movement_bonus generator_power
max_energy add_interface take_all can_move generator_energy max_solar_energy
available_in_batteries battery_capacity default_temperature max_temperature
heat_capacity pressure_to_speed_ratio flow_to_energy_ratio max_push_amount
ratio_to_push get_entity_count disable_research disable_all_prototypes
reset_recipes enable_all_recipes enable_all_technologies
research_all_technologies reset_technologies clear_chart is_chunk_charted
get_ammo_damage_modifier set_ammo_damage_modifier get_gun_speed_modifier
set_gun_speed_modifier get_turret_attack_modifier set_turret_attack_modifier
manual_mining_speed_modifier manual_crafting_speed_modifier
laboratory_speed_modifier logistic_robot_speed_modifier
logistic_robot_storage_modifier current_research inserter_stack_size_bonus
character_logistic_slot_count quickbar_count maximum_following_robot_count
ghost_time_to_live manual_mining_speed_modifier manual_crafting_speed_modifier
laboratory_speed_modifier logistic_robot_speed_modifier
logistic_robot_storage_modifier current_research inserter_stack_size_bonus
character_logistic_slot_count quickbar_count maximum_following_robot_count
ghost_time_to_live desync_players on_init on_load on_save on_event
get_event_handler generate_event_name raise_event set_game_state
get_entity_by_tag show_message_dialog print_entity_statistics
disable_tips_and_tricks freeze_daytime get_localised_item_name
get_localised_entity_name get_localised_technology_name is_pathfinder_busy
kill_all_enemies is_demo reload_script save_atlas regenerate_tiles
regenerate_entity take_screenshot remove_path get_player remove_offline_players
force_crc always_day evolution_factor map_settings entity_prototypes
item_prototypes fluid_prototypes peaceful_mode wind_speed wind_orientation
wind_orientation_change evolution_factor peaceful_mode wind_speed
wind_orientation wind_orientation_change inventory_order children_names
player_index can_insert get_item_count is_empty get_contents has_flag stack_size
fuel_value place_result magazine_size default_request_amount item_to_clear
has_grid blueprint_icons blueprint_icons is_blueprint_setup
get_blueprint_entities set_blueprint_entities add_ammo drain_ammo
set_ending_screen_data clear_console get_goal_description set_goal_description
set_controller has_game_view build_from_cursor rotate_for_build
disable_recipe_groups opened_self controller_type cursor_position
game_view_settings minimap_enabled cursor_position game_view_settings
minimap_enabled''')

old_names = [name.replace('_', '') for name in new_names]

old_names.append('glob')
new_names.append('global')

def process(script):
  print '{0}...'.format(script)
  
  def process_line(line):
    for old, new in zip(old_names, new_names):
      line = line.replace(old, new)
    return line

  content = []
  with open(script) as f:
    content = [process_line(l) for l in f]
  open(script, 'w').writelines(content)

if len(sys.argv) > 1 and sys.argv[1] == '--help':
  print '{0} [directory]'.format(sys.argv[0])
  print
  print 'Arguments:'
  print '  directory: Mods directory to operate on. Default: ./mods'

  sys.exit(0)

dir = sys.argv[1] if len(sys.argv) >= 2 else 'mods'

for mod, subdirs, files in os.walk(dir):
  for f in (f for f in files if f.endswith('.lua')):
    process(os.path.join(mod, f))
else:
  print >> sys.stderr, 'No mods found in {0}'.format(dir)
